#include "MainWindow.h"
#include "ui_MainWindow.h"

#include <QDir>
#include <QNetworkDiskCache>
#include <QNetworkReply>
#include <QNetworkRequest>
#include <QStandardPaths>
#ifdef Q_OS_ANDROID
#  include <QAndroidJniObject>
#  include <QAndroidJniEnvironment>
#  include <QtAndroid>
#include <QDesktopServices>
#endif

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    m_nam = new QNetworkAccessManager (this);
    auto dk = new QNetworkDiskCache (this);
    qDebug() << QStandardPaths::writableLocation (QStandardPaths::CacheLocation);
    dk->setCacheDirectory(QStandardPaths::writableLocation (QStandardPaths::CacheLocation) + "/.httpCache");
    m_nam->setCache(dk);
    connect (ui->pushButton, SIGNAL(clicked(bool)), this, SLOT(onFetch()));
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::onFetch()
{
    QNetworkRequest req (QUrl("http://192.168.0.100/test.txt"));
    auto reply = m_nam->get (req);
    connect (reply, &QNetworkReply::finished, this, [reply, this] {
        reply->deleteLater ();
        ui->lineEdit->setText(QString::fromUtf8(reply->readAll()).split ("\n").first ());
    });
}
